/*
 *  linux/include/asm-arm/arch-ep93xx/platform.h
 *
 *  Copyright (C) 2002-2003 Cirrus Logic, Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
#ifndef PLATFORM_H
#define PLATFORM_H

#ifdef CONFIG_ARMADILLO9_ISA
#define MISC8_BASE_VIRT     0xF0000000
#define MISC8_BASE_PHYS     0x10000000
#define MISC8_SIZE          0x04000000
#define MISCREG_BASE        (MISC8_BASE_VIRT)
#define ISAIO8_BASE         (MISC8_BASE_VIRT + 0x02000000)
#define ISAMEM8_BASE        (MISC8_BASE_VIRT + 0x03000000)

#define MISC16_BASE_VIRT    0xF4000000
#define MISC16_BASE_PHYS    0x20000000
#define MISC16_SIZE         0x04000000
#define ISAIO16_BASE        (MISC16_BASE_VIRT + 0x02000000)
#define ISAMEM16_BASE       (MISC16_BASE_VIRT + 0x03000000)

#include <asm/types.h>

#define MISCREG(type,off) (*(volatile type *)(MISCREG_BASE + off))

#define MISCREG_INTCR1    MISCREG(u8, 0x0)
#define MISCREG_INTCR2    MISCREG(u8, 0x2)
#define MISCREG_INTCR3    MISCREG(u8, 0x4)
#define MISCREG_INTMR1    MISCREG(u8, 0x8)
#define MISCREG_INTMR2    MISCREG(u8, 0xa)
#define MISCREG_INTMR3    MISCREG(u8, 0xc)
#define MISCREG_ISAMODE   MISCREG(u8, 0xe)
#define MISCREG_INTSR1    MISCREG_INTCR1
#define MISCREG_INTSR2    MISCREG_INTCR2
#define MISCREG_INTSR3    MISCREG_INTCR3

#define MISCREG_ISA15     (1 << 2)
#define MISCREG_ISA14     (1 << 1)
#define MISCREG_ISA12     (1 << 0)
#define MISCREG_ISA11     (1 << 3)
#define MISCREG_ISA10     (1 << 2)
#define MISCREG_ISA9      (1 << 1)
#define MISCREG_ISA7      (1 << 0)
#define MISCREG_ISA6      (1 << 3)
#define MISCREG_ISA5      (1 << 2)
#define MISCREG_ISA4      (1 << 1)
#define MISCREG_ISA3      (1 << 0)

#define MISCREG_ISAFAST   (1 << 1)

#ifdef __KERNEL__
extern volatile u8 miscreg_intmr1;
extern volatile u8 miscreg_intmr2;
extern volatile u8 miscreg_intmr3;
extern volatile u8 miscreg_isamode;
#endif
#endif

#ifdef CONFIG_ARCH_ARMADILLO2X0
typedef enum _board_id_e{
  BOARD_ID_UNKONWN = -1,
  BOARD_ID_A210 = 0,
  BOARD_ID_A220,
  BOARD_ID_A230,
  BOARD_ID_A240,
  BOARD_ID_A210C,
}board_id_e;

#define get_board_id() ((inl(GPIO_PHDR) >> 2) & 0x7)
#define get_board_sdram32bit() ((inl(GPIO_PHDR) >> 5) & 0x1)

#ifdef CONFIG_ARCH_ARMADILLO230
#define LAN911X_BASE_VIRT 0xFE700000
#define LAN911X_BASE_PHYS 0x70000000
#define LAN911X_SIZE      0x00100000
#endif
#endif

#endif
